Ruby: ext/fiddle/libffi-3.2.1/src/moxie/ffi.c File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Functions
ffi.c File Reference
`#include <ffi.h>`
`#include <ffi_common.h>`
`#include <stdlib.h>`

Go to the source code of this file.

## Functions
void * | ffi_prep_args (char *stack, extended_cif *ecif)
ffi_status | ffi_prep_cif_machdep (ffi_cif *cif)
void | ffi_call_EABI (void *(*)(char *, extended_cif *), extended_cif *, unsigned, unsigned, unsigned *, void(*fn)(void))
void | ffi_call (ffi_cif *cif, void(*fn)(void), void *rvalue, void **avalue)
void | ffi_closure_eabi (unsigned arg1, unsigned arg2, unsigned arg3, unsigned arg4, unsigned arg5, unsigned arg6)
ffi_status | ffi_prep_closure_loc (ffi_closure *closure, ffi_cif *cif, void(*fun)(ffi_cif *, void *, void **, void *), void *user_data, void *codeloc)

## Function Documentation

## ◆ ffi_call()

void ffi_call | ( | ffi_cif * | cif,
|  | void(*)(void) | fn,
|  | void * | rvalue,
|  | void ** | avalue
| ) |  |

Definition at line 125 of file ffi.c.

References alloca, extended_cif::avalue, extended_cif::cif, FFI_ASSERT, ffi_call_EABI(), FFI_EABI, ffi_prep_args(), NULL, and extended_cif::rvalue.

## ◆ ffi_call_EABI()

void ffi_call_EABI | ( | void * | *)(char *, extended_cif *,
|  | extended_cif * | ,
|  | unsigned | ,
|  | unsigned | ,
|  | unsigned * | ,
|  | void(*)(void) | fn
| ) |  |

## ◆ ffi_closure_eabi()

void ffi_closure_eabi | ( | unsigned | arg1,
|  | unsigned | arg2,
|  | unsigned | arg3,
|  | unsigned | arg4,
|  | unsigned | arg5,
|  | unsigned | arg6
| ) |  |

Definition at line 158 of file ffi.c.

References alloca, NULL, and ptr.

## ◆ ffi_prep_args()

void * ffi_prep_args | ( | char * | stack,
|  | extended_cif * | ecif
| ) |  |

Definition at line 35 of file ffi.c.

References ALIGN_DOWN, extended_cif::avalue, extended_cif::cif, count, FFI_ASSERT, int(), memcpy, and extended_cif::rvalue.

## ◆ ffi_prep_cif_machdep()

ffi_status ffi_prep_cif_machdep | ( | ffi_cif * | cif | ) |

Definition at line 107 of file ffi.c.

References ALIGN.

## ◆ ffi_prep_closure_loc()

ffi_status ffi_prep_closure_loc | ( | ffi_closure * | closure,
|  | ffi_cif * | cif,
|  | void(*)(ffi_cif *, void *, void **, void *) | fun,
|  | void * | user_data,
|  | void * | codeloc
| ) |  |

Definition at line 245 of file ffi.c.

References ffi_closure_eabi(), FFI_EABI, and long().